<?php
/*
 * $Id: index.php,v 1.8 2005/01/09 12:56:42 veghead Exp $
 */
define("WSVER",'$Id: index.php,v 1.8 2005/01/09 12:56:42 veghead Exp $');

if (!file_exists("config.php")) {
	print("<h1>Aiiieee! Please install this properly (clue: README)</h1>");
	exit;
}

include("config.php");
include("functions-inc.php");
include("vfs-".$conf['vfstype'].".php");


/* Useful */
$PHP_SELF = $_SERVER["PHP_SELF"];
$error_message="";


/* Variables from the outside world */
$user=(! empty($_POST['user'])) ? $_POST['user'] : 0;
$passwd=(! empty($_POST['passwd'])) ? $_POST['passwd'] :0 ;
$fileactions=(! empty($_POST['cb'])) ? $_POST['cb'] : array();
$mimetype=(! empty($_GET['mimetype']) ? $_GET['mimetype'] : 0);
$file=(! empty($_REQUEST['file']) ? $_REQUEST['file'] : 0);
$act=(! empty($_REQUEST['act'])) ? $_REQUEST['act'] : "NOACTION";
$newdir=(! empty($_REQUEST['newdir']) ? $_REQUEST['newdir'] : 0);
$download=(! empty($_REQUEST['d'])) ? 1 : 0;
if (! empty($_FILES['filename'])) {
	$tmpFilename=$_FILES['filename']['tmp_name'];
	$origFilename=$_FILES['filename']['name'];
} else {
	$tmpFilename="";
	$origFilename="";
}
$pwd=(! empty($_REQUEST['pwd'])) ? $_REQUEST['pwd'] : "";
$mode=(! empty($_REQUEST['mode'])) ? $_REQUEST['mode'] : "rw-------";
if (! empty($_REQUEST['p0'])) {
	$perms= ((is_numeric($_REQUEST['p0'])) ? $_REQUEST['p0'] : 0 )+
		((is_numeric($_REQUEST['p1'])) ? $_REQUEST['p1'] : 0 )+
		((is_numeric($_REQUEST['p2'])) ? $_REQUEST['p2'] : 0 )+
		((is_numeric($_REQUEST['p3'])) ? $_REQUEST['p3'] : 0 )+
		((is_numeric($_REQUEST['p4'])) ? $_REQUEST['p4'] : 0 )+
		((is_numeric($_REQUEST['p5'])) ? $_REQUEST['p5'] : 0 )+
		((is_numeric($_REQUEST['p6'])) ? $_REQUEST['p6'] : 0 )+
		((is_numeric($_REQUEST['p7'])) ? $_REQUEST['p7'] : 0 )+
		((is_numeric($_REQUEST['p8'])) ? $_REQUEST['p8'] : 0 );
}
$setlanguage=(!empty($_REQUEST['setlanguage'])) ? $_REQUEST['setlanguage']:0;



ini_set("session.name",$conf['session_name']);
session_start();
$sessionID=session_id();

if ((! $setlanguage)&&((! empty($_SESSION['language'])))) {
	$setlanguage=$_SESSION['language'];
}

if (preg_match('/^\w\w-\w\w$/',$setlanguage)) {
	$conf['lang']=$setlanguage;
}



/* Pseudo NLS stuff - messy - very messy */

/* 
 * Load the default language, in case a translation doesn't exist in
 * the language file.
 */
include("lang/".$conf['default_lang'].".php");

if (file_exists("lang/".$conf['lang'].".php")) {
	include("lang/".$conf['lang'].".php");
}
$_SESSION['language']=$conf['lang'];

$showlisting=1;
$sessionvalid=0;


/* 
 * First we make sure this isn't a "utility" request 
 * if it is then display the utility 
 */
if ((! empty($_REQUEST['utilchmod'])) && ($file || count($fileactions))) {
	include("chmod.php");
	exit;
} elseif ((! empty($_REQUEST['utilchmod']))) {
	$error_message=$conf['nls']['select_files_first'];
}


/* Do we have an active session ? */
if ($sessionID && file_exists("ftp_sessions/".$sessionID) &&
		$_SESSION['pad']) {
	$fhs=@fopen("ftp_sessions/$sessionID","r");
	// Hopefully - fopen doesn't alter the atime. Otherwise
	// this won't work :(
	$st=@fstat($fhs);
	// fread does - so we stat it first.
	$data=@fread($fhs,150);
	fclose($fhs);
	$data_ex = explode("|",$data);
	$ftp_user_name = trim($data_ex[0]);
	$encpass = trim($data_ex[1]);
	$ftp_user_pass = $_SESSION['pad']^(base64_decode($encpass));
	
	if (time() - ($st['atime']) <= $conf['session_timeout']) {
		$sessionvalid=1;
	} else {
		// Session expired - remove the session file!
		@unlink("ftp_sessions/$sessionID");
		loginPage($conf['nls']['session_expired']."<br>");
		die();
	}



/* 
 * So, no valid session and a blank username and password ?
 * clean up some mess in the session directory and spew the form
 */
} elseif (empty($user) and empty($passwd)) {
	if (file_exists("ftp_sessions/".$sessionID) and !empty($sessionID)) {
		unlink("ftp_sessions/".$sessionID);
	}

	loginPage();
	die();
/*
 * No active session - but a username and password. Let's give them a go
 */
} else {
	$ftp_user_name = $user;
	$ftp_user_pass = $passwd;
}


/* Create vfs object - also connects */
$wvfs = new oliver_vfs($conf);
$conn_id=$wvfs->cid;


/* Try a login */
$login_result = $wvfs->login("$ftp_user_name", "$ftp_user_pass");


/* Could we connect ? */
if ((!$conn_id) || (!$login_result)) {

	/* No - throw up a form */

	$errbanner=$conf['nls']['ftp_connect_failed']."<br>(";
	$errbanner.=$conf['nls']['attempted_connect_to']." ";
	$errbanner.=$conf['ftp_server']." ";
	$errbanner.=$conf['nls']['for_user']." $ftp_user_name )";

	loginPage($errbanner);

	die;
} else {
	/* 
	 * Yay! They logged in!
	 * If the pad isn't set, set it and create the session file.
	 * "pad" sounds better than "nonce" you see...
	 */
	if (!$sessionvalid) {
		$pad=md5(rand().microtime());
		$_SESSION['pad']=$pad;
		$encpass=base64_encode($pad^$ftp_user_pass);
		$fp=@fopen("ftp_sessions/$sessionID","w");
		if (!$fp) {
			print("<h1>Can't write session</h1><i>");
			print("Have you set the permissions correctly ?</i>");
			exit();
		}
		@fwrite($fp,"$ftp_user_name|$encpass");
		@fclose($fp);
	}
}

/* At this point we're logged in and everything's groovy */


/* Firstly, make sure we're in the right place */
if (!$pwd) {
	$pwd = $wvfs->get_pwd();
} else {
	$pwd = urldecode($pwd);
	$wvfs->chdir($pwd);
}


if ($act == "chdir") {
	$new_dir=urldecode($file);
	if (! preg_match('/^\//',$new_dir)) {
		$new_dir = urldecode($pwd)."/".$new_dir;
	}
	if (! ($wvfs->chdir($new_dir))) {
		$error_message="Can't Open Folder";
	}
}


if ($act == "cdup") {
	$wvfs->cdup();
}

if ($act == "getfile") {
	$ip = getenv("REMOTE_ADDR");
	$local_file = "ftp_cache/$sessionID.$ip.get";
	if (@ftp_get($conn_id,$local_file,$file,FTP_BINARY)) {
		if ($download) {
			$mimetype="application/octet-stream";
		}
		$mimetype=$mimetype ? $mimetype : "application/octet-stream";

		header("Pragma: public");
		header("Expires: 0"); /* set expiration time */
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Content-Type: application/force-download");
		header("Content-type: $mimetype");
		header("Content-Disposition: filename=$file");
		header("Content-Length: ".filesize($local_file));

		$fd=fopen($local_file,"rb");
		while (!feof($fd)) {
			print(fread($fd,8192));
		}
		fclose($fd);
		unlink("$local_file");
		exit;
	} else {
		$error_message=$conf['nls']['download_failed'];
	}
}

if ($act == "logout") {
	if ($sessionID and file_exists("ftp_sessions/".$sessionID)) {
		unlink("ftp_sessions/".$sessionID);
		$sessionID="";
		$user="";
		$pass="";
		$ftp_user_name = "";
		$ftp_user_pass = "";
		unset($_SESSION['pad']);
		loginPage();
		die;
	}
}


$pwd = $wvfs->get_pwd();

showHeader();

if (!empty($_POST['actdel'])) {
	$deleted=0;
	foreach($fileactions as $key => $value)  {
		$tobedeleted = urldecode($pwd)."/".urldecode($key);
		if ($wvfs->delete($tobedeleted)) {
			$deleted++;
		} else {
			if ($wvfs->rmdir($tobedeleted)) {
				$deleted++;
			} else {
				$error_message.="$key: ".
					$conf['nls']['delete_failed']."\\n";
			}
		}
	}
	$error_message.="\\n$deleted file(s) deleted\\n";
	
} elseif (($conf['enable_chmod']) && 
		(!empty($_POST['actchmod']))&&($perms)&&($fileactions)) {

	foreach($fileactions as $key => $value)  {
		$key=urldecode($key);
		if (! ($wvfs->chmod($key,decoct($perms)))) {
			$error_message.=$conf['nls']['cant_change_perms'].
								" $key\\n";
		} else {
			$error_message.=$conf['nls']['perms_changed'].
								" $key\\n";
		}
	}
} elseif (!empty($_POST['actmkdir'])) {
	if (! $wvfs->mkdir($newdir)) {
		$error_message.=$conf['nls']['dir_create_failed'].
							" $newdir\\n";
	} else {
		$error_message.=$conf['nls']['dir_created'].
							" $newdir\\n";
	}
} elseif (!empty($_POST['actup'])) {
	if (is_uploaded_file($tmpFilename)) {
		move_uploaded_file($tmpFilename,"ftp_cache/".$sessionID);
		ftp_put ($conn_id,$origFilename,"ftp_cache/".$sessionID, 
							FTP_BINARY);
		unlink("ftp_cache/".$sessionID);
	} else {
		$error_message .= "Upload of $origFilename failed!\\n";
	}
}

if (($sessionID)&&($showlisting)) {
        print("<p><b>".$conf['nls']['path']."</b> $pwd</p>");
}


/*
 * Display button bar
 */
print("<center><table border=\"0\" cellpadding=\"5\" cellspacing=\"5\"><tr>\n");

print("<td class=\"button\"><a class=\"button\" href=\"$PHP_SELF?act=cdup&amp;file=".urlencode($file)."&amp;pwd=$pwd\"><img src=\"graphics/parent.gif\" border=\"0\" width=\"16\" height=\"16\" alt=\"Parent\"><br>".$conf['nls']['up']."</a></td>");
print("<td class=\"button\"><a class=\"button\" href=\"$PHP_SELF?sessionID=$sessionID\"><img src=\"graphics/home.gif\" border=\"0\" width=\"16\" height=\"16\" alt=\"".$conf['nls']['home']."\"><br>".$conf['nls']['home']."</a></td>");

if (sizeof($conf['roots'])>0) {
	foreach($conf['roots'] as $key => $value) {
		print("<td class=\"button\"><a class=\"button\" href=\"$PHP_SELF?pwd=$value\"><img src=\"graphics/gollem.gif\" border=\"0\" width=\"16\" height=\"16\" alt=\"$key\"><br>$key</a></td>\n");
    }
}

print("<td class=\"button\"><a class=\"button\" href=\"$PHP_SELF?sessionID=$sessionID&amp;act=logout&amp;file=&amp;pwd=$pwd\"><img src=\"graphics/logout.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"".$conf['nls']['logout']."\"><br>".$conf['nls']['logout']."</a></td>\n");
print("</tr></table>\n");

// Get a list of files
$list = $wvfs->ls($pwd);

// Remove the files in the veto list
$pa=array();
foreach($list as $key => $dirline) {
	if(empty($conf['veto_filenames'][getFilename($dirline,0)])) {
		array_push($pa,$dirline);
	} 
}

$i=0;
$n = count($pa) - 1;



/* Error message if it exists */
if ($error==1) {
	$error_message = $conf['nls']['cant_create']." \"".urldecode($file)."\"".$conf['nls']['already_exists'];
}

if ($error_message) {
	print "<script language=\"JavaScript\">\n";
	print "<!--\n";
	print "alert('$error_message');\n";
	print "//-->\n";
	print "</script>\n";
	print "<noscript>\n";
	print "<p><b>Status:".preg_replace('/[^\w\s]n/','<br>',$error_message);
	print "</b></p>\n";
	print "</noscript>\n";
}

print("<form name=\"indexform\" method=\"post\" enctype=\"multipart/form-data\" action=\"$PHP_SELF?pwd=$pwd\">\n");
print("<input type=hidden name=sessionID value=$sessionID>\n");
print("<center>\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" width=\"100%\">\n");
print("<tr><td class=\"tableborder\">");
print("\n<table bgcolor=\"#ffffff\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">\n");

$newdirname=$conf['nls']['new_directory'];
$newdirid="";

if ($n >= 0) {
	print("<tr class=\"tablecell\">\n<td width=1><!-- <input type=checkbox name=tog onclick=\"javascript:toggle();\"> -->&nbsp;</td>\n");
	print("<td colspan=\"2\">".$conf['nls']['file_name']."</td>\n");
	print("<td>".$conf['nls']['owner']."</td>\n");
	print("<td>".$conf['nls']['permissions']."</td>\n");
	print("<td>".$conf['nls']['last_mod']."</td>\n");
	print("<td>".$conf['nls']['size']."</td>\n");
	print("</tr>\n");
	
	
	/* display each file on a line of its own */
	for ($i = 0; $i <= $n; $i++) {
		$pa[$i] = trim($pa[$i]);
	
		$cor=($i%2) ? "even" : "odd";
	
		print("<tr class=\"$cor\">\n");
		/* tick box */
		print("<td width=1>");
		print("<input type=\"checkbox\" name=\"cb[".
				urlencode(getFilename($pa[$i],0))."]\">");
		print("</td>\n");

		/* icon */
		print("<td valign=\"middle\" align=\"left\" width=1>");
		if ((getFileType($pa[$i])=="d")||(getFileType($pa[$i])=="l")) {
			print getFileTypeIcon($pa[$i]);
		} else {
			$fname=getFilename($pa[$i],0);
			print "<a target=\"new\" href=\"$PHP_SELF?sessionID=$sessionID&amp;act=getfile&amp;pwd=".urlencode($pwd)."&amp;mimetype=".urlencode(getMIMEType($pa[$i]))."&amp;file=$fname&amp;d=1\">";
			print getFileTypeIcon($pa[$i])."</a>";
		}
		print("</td>");

		/* filename */
		print("<td valign=\"middle\" align=\"left\">");
		if ((getFileType($pa[$i])=="d")||(getFileType($pa[$i])=="l")) {
			$fname=urlencode(getFilename($pa[$i],2));
			if ($fname==urlencode($newdirname.$newdirid)) {
				$newdirid++;
			}
			print "<a href=\"$PHP_SELF?sessionID=$sessionID&amp;act=chdir&amp;pwd=".urlencode($pwd)."&amp;file=$fname";
		} else  {
			$fname=urlencode(getFilename($pa[$i],0));
			print "<a target=\"new\" href=\"$PHP_SELF?sessionID=$sessionID&amp;act=getfile&amp;pwd=".urlencode($pwd)."&amp;mimetype=".urlencode(getMIMEType($pa[$i]))."&amp;file=$fname";
		}
	
	
		print "\">".htmlentities(getFilename($pa[$i],1))."</a>";
		print("</td>\n");

		/* owner */
		print("<td valign=\"middle\" align=\"left\">");
		print getOwner($pa[$i]);
		print("</td>\n");

		/* mode */
		$mode=getFileMode($pa[$i]);
		$umode=urlencode($mode);
		?>
<td valign="middle" align="left"><tt>
<?php
if ($conf['enable_chmod']) {
	?>
<a href="<?= $PHP_SELF ?>?pwd=<?= $pwd ?>&amp;file=<?= $fname ?>&amp;mode=<?= $umode ?>&amp;utilchmod=1">
<?= $mode ?></a>
	<?php
} else {
	print($mode);
}
?>
</tt>
</td>		
		<?php

		/* lastmod */
		print("<td valign=\"middle\" align=\"left\">");
		print getFileDate($pa[$i]);
		print("&nbsp;</td>\n");

		/* size */
		print("<td valign=\"middle\" align=\"left\">");
		$tam = $wvfs->size(getFilename($pa[$i],0));
		print FileTam($tam);
		print("&nbsp;</td>\n");
		print("</tr>\n");
	}
} else {
	print("<tr class=\"even\">");
	print("<td colspan=\"3\"><center><b>".$conf['nls']['empty_directory'].
							"</b></center></td>");
	print("</tr>\n");
}

/* get the decor right */
$cor=($i%2) ? "even" : "odd";

/* suggestion for the name of a new directory */
$newdirname.=$newdirid;

/* invite the user to create a directory */
print("<tr class=\"$cor\"><td>&nbsp;</td>");
print("<td valign=\"middle\" align=\"left\" width=1>");
print("<img src=\"".$conf['imgdir']."/dir.gif\" alt=\"\"></td>");
print("<td colspan=\"5\"><input type=\"text\" size=\"20\" name=\"newdir\" ");
print("value=\"$newdirname\">&nbsp;");
print("<input type=\"submit\" name=\"actmkdir\" ");
print(" value=\"".$conf['nls']['create_new_directory']."\" class=\"bopt\">");
print("</td>");

/* Buttons! */
print("<tr><td class=\"topt\" colspan=\"".$conf['listcols']."\">");
if ($conf['enable_chmod']) {
	print("<input class=\"bopt\" type=\"submit\" name=\"utilchmod\" value=\"".$conf['nls']['change_perms']."\"> | ");
}
print("<input class=\"bopt\" type=\"submit\" name=\"actdel\" value=\"".$conf['nls']['delete']."\">");
print(" | <input class=\"bopt\" type=\"submit\" name=\"actup\" value=\"".$conf['nls']['upload']."\">");
print("&nbsp;<input type=\"file\" name=\"filename\" value=\"\">&nbsp;");
print("</td></tr>");
print("\n</table>");
print("</td></tr>\n</table>");
print("</center></form>");


/* close the FTP stream */
$wvfs->quit();

showFooter();
?>
