<?php
/*
 * $Id: vfs-ftp.php,v 1.1.1.1 2004/07/22 09:52:51 veghead Exp $
 */
ini_set('display_errors','On');

class oliver_vfs {
	var $conf="";
	var $cid;

	function oliver_vfs($conf) 
	{
		$this->conf=$conf;
		$this->cid=@ftp_connect($this->conf['ftp_server'],
					$this->conf['ftp_server_port'],
					$this->conf['ftp_timeout']);
	}


	function login($user,$pass) 
	{
		if (! ($res=@ftp_login($this->cid,$user,$pass))) {
			return($res);
		}
		@ftp_pasv($this->cid,$this->conf['ftp_passive']);
		return($res);
	}

	function get_pwd()
	{
		return(@ftp_pwd($this->cid));
	}

	function chmod($file,$mode)
	{
		return(@ftp_site($this->cid,"chmod $mode ".$file));
	}

	function chdir($pwd)
	{
		return(@ftp_chdir($this->cid,$pwd));
	}

	function rmdir($todel)
	{
		return(@ftp_rmdir($this->cid,$todel));
	}

	function cdup()
	{
		return(@ftp_cdup($this->cid));
	}

	function get($local_file,$file,$fl)
	{
		return(@ftp_get($this->cid,$local_file,$file,$fl));
	}

	function put($local_file,$file,$fl)
	{
		return(@ftp_put($this->cid,$local_file,$file,$fl));
	}

	function delete($todel)
	{
		return(@ftp_delete($this->cid,$todel));
	}

	function ls($dir)
	{
		return(@ftp_rawlist($this->cid,$dir));
	}

	function size($name)
	{
		return(@ftp_size($this->cid,$name));
	}

	function mkdir($name)
	{
		return(@ftp_mkdir($this->cid,$name));
	}

	function quit()
	{
		return(@ftp_quit($this->cid));
	}
}
?>
